package letzplay.core;

public class Task implements Trigger {
    private String title;
    private String description;
    private boolean done;
    private String trigger;

    public Task(String title, String description, String trigger) {
        this.title = title;
        this.description = description;
        this.trigger = trigger;
        this.done = false;
    }

    private void complete() {
        done = true;
    }

    public boolean isDone() {
        return done;
    }

    public String getTitle() {
        return title;
    }

    public String getDescription() {
        return description;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (!(obj instanceof Task))
            return false;
        Task other = (Task) obj;

        return this.getTitle().equals(other.getTitle()) &&
                this.getDescription().equals(other.getDescription());

    }

    @Override
    public String toString() {
        return title + "\n" + description + "\nDone: " + done + "\n";
    }

    @Override
    public void trigger(String msg) {
        if (trigger.equals(msg)) {
            complete();
        }
    }

    public String getTrigger() {
        return trigger;
    }
}
