package letzplay.core;


import letzplay.core.GameEngine;
import letzplay.ganttproject.GanttProject;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Test;
import letzplay.core.Quest;
import letzplay.core.Task;

import static org.junit.jupiter.api.Assertions.assertEquals;

class GameEngineTest {
    static GameEngine game;

    @BeforeAll
    public static void beforeAll() {
        game = GameEngine.getInstance();
        game.initQuests(GanttProject.init());
    }

    @Test
    public void testInit() {
        assertEquals(game.availableQuests().size(), 1);
        assertEquals(game.currentLvl(), 0);
    }

    @Test
    public void testQuestComplete() {
        Quest quest = game.availableQuests().get(0);
        for (Task t : quest.getTaskList()
        ) {
            t.trigger(t.getTrigger());
        }

        game.update();

        assertEquals(game.currentLvl(), 1);
        assertEquals(game.doneQuests().size(), 1);
    }

}