package letzplay.core;

import letzplay.core.Quest;
import letzplay.core.Task;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class TaskTest {
    private String title = "title";
    private String description = "description";
    private String trigger = "trg";

    @Test
    void testTaskCreation() {
        Task task = new Task(title, description, trigger);

        assertEquals(task.getDescription(), description);
        assertEquals(task.getTitle(), title);
        assertFalse(task.isDone());
    }

    @Test
    void testTaskComplete() {
        Task task = new Task(title, description, trigger);

        task.trigger("trg");

        assertEquals(task.getDescription(), description);
        assertEquals(task.getTitle(), title);
        assertTrue(task.isDone());
    }

    @Test
    void testTaskCanBeEqual() {
        Task task1 = new Task(title, description, trigger);
        Task task2 = new Task(title, description, trigger);

        assertEquals(task1, task2);
    }

    @Test
    void testTaskCanBeUnequal() {
        Task task1 = new Task(title, description, trigger);
        Task task2 = new Task(title + 1, description, trigger);

        assertNotEquals(task1, task2);
        assertNotEquals(null, task1);
        assertNotEquals(task1, new Quest(title, description, 0, 0));
    }
}